#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"
##########################################################################
# Developer : Binny V A                                                  #
# Website   : http://www.geocities.com/binnyva                           #
# E-Mail    : binnyva@rediffmail.com                                     #
# Get more Tcl/Tk scripts from http://www.geocities.com/binnyva/code/tcl #
##########################################################################
# Name         : Usenet Reader                                           #
# Version      : 3.01.A                                                  #
# Started Date : September 26, 2004                                      #
# Description  :                                                         #
# Read the Archived UseNet messages stored in a predefined folder        #
# 	Created to be used with archived Comp.Lang.Tcl usenet messages       #
#   available at http://www.oche.de/~akupries/tcltk.html#clt-arch        #
#                                                                        #
# Get more Tcl/Tk scripts from http://www.geocities.com/binnyva/code/tcl #
##########################################################################

########################### Global Variables #############################
#Specify the dirctory in which the archives are kept.
set archive_folder "[file dirname $argv0]"

set home_folder "[file dir $argv0]"
set option_file "[file join $home_folder uar.opt]"
set msg_files {}

#Information about the program
array set program {
	name		"UseNet Archive Reader"
	version		"3.00.A"
	author		"Binny V Abraham"
	website		"http://www.geocities.com/binnyva"
	email		"binnyva@hotmail.com"
}
#Info about the current message
array set msg_info {
	subject		""
	file_name	""
	file_path	""
	from		""
	date		""
	email		""
	org			""
	line_no		0
}
#The date of the message
array set date {
	year		"2001"
	month		"1"
	day			"1"
}
#The buttons that are disabled.
array set current {
	day			""
	month		""
	subject		""
	show_only	0
}
#The colour of buttons.
array set colours {
	current		"blue"
	normal		"black"
}
#Options
array set opt {
	show_replys		1
	use_big_font	0
	use_vertical	0
}

#Open the currently displayed message in notepad
proc openForEdit { } {
	global archive_folder msg_info
	set argument "$msg_info(file_path)/$msg_info(file_name)"
	regsub -all "/" $argument "\\" new
	if { [file exist $argument] && ![file isdirectory $argument] } {
	 	catch { exec notepad "$new" & }
 	} else {
	 	tk_messageBox -message "Error! Please specify a valid file/message." -icon error
 	}
}

#Get the subject in a specified day.
proc getSubjects { day } {
	global archive_folder msg_files msg_info current date
	global colours opt
	
	#Clear the last display
	.subjects delete 0 end
	set msg_files {}

	#If there is a 'current' button, make it 'normal'.
	if { $current(day) != "" } {
		$current(day) configure -fg $colours(normal)
	}
	#Give 'current' colour to the clicked date
	set day [expr $day]
	.days.day_$day configure -fg $colours(current)
	set current(day) ".days.day_$day"

	#The date must be in the format '05'
	if { $day < 10 } {
		set day_name "0$day"
	} else {
		set day_name $day
	}
	#Similarly the month
	if { $date(month) < 10 } {
		set month_name "0$date(month)"
	} else {
		set month_name $date(month)
	}
	#Set the global variables accodingly
	set date(day) $day_name
	.date configure -text "$day_name/$month_name/$date(year)"

	set count 0
	#Change to that Directory
	set file_path [file join $archive_folder $date(year) $month_name $day_name ".subject"]

	#If there is no '.subject' file, get the subjects form every single file
	if { ![file exist "$file_path"] } {
		#Everthing from here is copied form SubjectTaker.pl V2.00.A and converted to Tcl
		# Get a list of all matching files
		set folder "[file join $archive_folder $date(year) $month_name $day_name]"
		
		#If there is no such folder
		if { ![catch { cd "$folder" }] } {
			set files [lsort [glob -nocomplain "*.*"]]
			set data_day ""
			set sub_count 0 
			set current_folder "[file join $month_name $day_name]"
			
			foreach fl $files {
				if { $fl != ".subject" } {
					set flag 0
					set FILE [open "$fl" r]
					
					while { !$flag } {
						set line [gets $FILE]
						if { [regexp -all -nocase "Subject: (.*)" $line full_match re1] } {
							incr sub_count
							set flag 1 
							if { [string length $re1] > 2 } {
				 				append data_day "$current_folder/$fl:Subject: $re1\n"
							}
							break
						}
					}
					close $FILE
				}
			}
			
			if { $flag }  {
				#Write the subject file
				#The catchs are there so that no error will come even if it is 
				#	run from a CD-ROM(non writeable medium)
				if { ![catch { set OUTFILE [open ".subject" w]}] } {
				catch { puts $OUTFILE "$data_day"  }
					close $OUTFILE
				}
			}
	
			statu "Made new subject file with $sub_count messages." 5
		} else {
			statu "Error reading folder '$folder'." 6
		}
	}

	# Make sure the file exist(again) - To prevent error even if the folder is not there.
	if { [file exist "$file_path"] } {
		#Get the subjects from the '.subject' file.
		set msg_info(file_path) [file dirname $file_path]
	
		#Open the file
		set subs_file [open "$file_path" r]
		
		#Get all the subjects.
		set buffer [read $subs_file]
		close $subs_file
	
		set lines [split "$buffer" "\n"]
		foreach line $lines {
			set arr [split "$line" "\:"]
			incr count
			#Now take the subject names from it.
			set subject [join [lrange $arr 2 [llength $arr]] ":"]
			if { $subject != "" } {
				.subjects insert end "$subject"
			}
			lappend msg_files "[lindex $arr 0]"
		}
	
		.subjects selection set 0
		if { $current(show_only) } {
			showOnly
		} elseif { !$opt(show_replys) } {
			toogleReply
		} else {
	 		.msg_count configure -text "$count Message(s)."
		}
		.subjects selection set 0
	}
}

#Displays the selected message in the Message Area.
proc showPost { } {
	global msg_files msg_info date

	#Get the index number of the double-clicked subject
	set sel [.subjects curselection]
	set subject_name [.subjects get $sel]
	set file_name [file tail [lindex $msg_files $sel]]
	set file_name [file join $msg_info(file_path) $file_name]

	if { [file exist "$file_name"] } {
		#Clear Last display
		.msg delete 1.0 end

		set name [file tail $file_name]

		#Open the file
		set msg_file [open "$file_name" r]
		#Find the fisrt empty line. All before this is the header.
		set flag 1
		#Also get some information from the header
		set from ""
		set email ""
		set sent_date ""
		set organization ""
		set id ""
		set host ""
		while { $flag } {
			set line [gets $msg_file]
			if { $line == "" } {
				set flag 0
			} else {
				#If a thing is empty, search for it.
				if { $from == "" } {
					if { [regexp "From:(.+)" $line full wanted] } {
						regexp {(.*) .?([\w.-]+)\@([\w.-]+)} $wanted full from id host
						set email "$id\@$host"
					}
				}
				if { $sent_date == "" } {
					regexp "Date: (.+)" $line full sent_date
				}
				if { $organization == "" } {
					regexp "Organization: (.+)" $line full organization
				}
			}
		}
		#Get the rest of the fie and display it.
		set contents [read $msg_file]
		close $msg_file

		#Screen Display
		.msg insert end $contents
		.file_info configure -text "$name"

		if { [string length $subject_name] > 60 } {
			regexp "(.{60}).*" $subject_name full new_sub
			.subject_name configure -text "Subject:$new_sub..."
		} else {
			.subject_name configure -text "Subject:$subject_name"
		}

		if { $from == "" } {
			.from configure -text "$email"
		} else {
			.from configure -text "$from"
		}
		stat "Loaded $name"

		#Store the data
		set msg_info(file_name) "$name"
		set msg_info(subject) "$subject_name"
		set msg_info(line_no) "$sel"
		set msg_info(from) "$from"
		set msg_info(email) "$email"
		set msg_info(date) "$sent_date"
		set msg_info(org) "$organization"
	} else {
		tk_messageBox -message "$file_name dont exist." -icon error
	}
}

#Show information about current message
proc postInfo {} {
	global msg_info
	set i [toplevel .information]
	label $i.subject -text "Subject:$msg_info(subject)" -width 50
	label $i.file_info -text "File:$msg_info(file_name)"
	label $i.date -text "Sent Time:$msg_info(date)"

	labelframe $i.lfm_sender -text "Sender Info" -labelanchor nw
	label $i.from -text "Sender:$msg_info(from)"
	entry $i.email
	$i.email insert end "$msg_info(email)"	
	label $i.org -text "Organization:$msg_info(org)"

	button $i.but_edit -text "Edit Message" -command { openForEdit }
	button $i.ok -text "   OK   " -command { catch { destroy .information } }
	
	pack $i.subject -in $i
	pack $i.file_info -in $i
	pack $i.date -in $i
	pack $i.from  -in $i.lfm_sender
	pack $i.email -in $i.lfm_sender
	pack $i.org   -in $i.lfm_sender
	pack $i.lfm_sender -in $i -fill x
	pack $i.ok       -in $i -side left
	pack $i.but_edit -in $i -side right

	bind $i <Key-Escape> { catch { destroy .information } }
	wm title $i "Post Information"
}

#Hide or Show Reply posts - Hides the messages starting with 'Re:'
proc toogleReply { } {
	global msg_files opt date
	
	if { !$opt(show_replys) } {
		set subjects [.subjects get 0 end]
		set reply_count 0
		set msg_count 0
		
		for { set i 0 } { $i < [llength $subjects] } { incr i } {
			set sub [lindex $subjects $i]
			
			#If it is a reply...
			if { [string range $sub 0 4] == " Re: " } {
				incr reply_count
			} else {
			#...if it is not a reply.
				lappend new_subjects $sub
				lappend new_msg_files [lindex $msg_files $i]
				incr msg_count
			}
		}
		
		#Update the display
		.subjects delete 0 end
		foreach sub $new_subjects {
			.subjects insert end $sub
		}
		set msg_files $new_msg_files
	
		statu "$msg_count Messages are shown and $reply_count Replys are hidden." 5
		.msg_count configure -text "$msg_count Message(s)."
	} else {
		.subjects delete 0 end
		if { [string range $date(day) 0 0] == "0" } { 
			set day [string range $date(day) 1 1]
		} else {
			set day $date(day)
		}
		getSubjects $day
	}
}

#Show only one specifed subject and its replys
proc showOnly { } {
	global msg_files current date
	#Init
	set new_subjects {}
	set new_msg_files {}

	if { $current(subject) == "" } {
		#Get the index number of the selected subject
		set sel [.subjects curselection]
		if { $sel != "" } {
			set subject_name [.subjects get $sel]
			regsub {Re: } $subject_name {} subject_name ;# Removes 'Re: '
			set current(subject) $subject_name
		} else {
			set current(show_only) 0
		}
	} else {
		set subject_name $current(subject)
		regsub {Re: } $subject_name {} subject_name ;# Removes 'Re: '
	}
	
	if { $current(show_only) } {
		set subjects [.subjects get 0 end]
		set sub_count 0
		set msg_count 0
		
		for { set i 0 } { $i < [llength $subjects] } { incr i } {
			set sub [lindex $subjects $i]
			
			set subject_name [string trimleft $subject_name]
			set sub [string trimleft $sub]
			#If it is a subject we wanted...
			if { [string match $sub "Re: $subject_name"] || [string match $subject_name "$sub"]} {
				lappend new_subjects $sub
				lappend new_msg_files [lindex $msg_files $i]
				incr sub_count
			} else {
			#...if not.
				incr msg_count
			}
		}

		#Update the display
		.subjects delete 0 end
		foreach sub $new_subjects {
			.subjects insert end $sub
		}
		set msg_files $new_msg_files
	
		statu "$sub_count message(s) out of $msg_count messages are shown." 5
		.msg_count configure -text "$sub_count Message(s)."
	} else {
		.subjects delete 0 end
		set current(subject) ""
		set current(show_only) 0
		
		if { [string range $date(day) 0 0] == "0" } { 
			set day [string range $date(day) 1 1]
		} else {
			set day $date(day)
		}
		getSubjects $day
	}
}

#Make the buttons for all days of a month
proc makeDays { base type } {
	global colour
	for { set i 1 } { $i <= 31 } { incr i } {
		if { $type == "menu" } {
			$base add command -label "$i" -command "getSubjects $i"
		} else {
			button $base.day_$i -text "$i" -command "getSubjects $i"
			pack $base.day_$i -side left
		}
	}
}

#Change year and show the posts of January 1st
proc setYear { year all } {
	global date
	set date(year) $year
	.months.mb_year configure -text "Year:$year"
	if { $all } {
		monthDays 1
 		getSubjects 1
	}
}

#Enable all the days in the given month and disable the others
proc monthDays { month } {
	global date current colours

	set date(month) $month
	#Feb - leap year consideration.
	if { $date(year) % 4 == 0 } {
		set month_days { 0 31 29 31 30 31 30 31 31 30 31 30 31 }
	} else {
		set month_days { 0 31 28 31 30 31 30 31 31 30 31 30 31 }
	}
	set month_name { "" "jan" "feb" "mar" "apr" "may" "june" "july" "aug" "sept" "oct" "nov" "dec" }
	set base ".days"

	set days [lindex $month_days $month]
	for { set i 1 } { $i <= $days } { incr i } {
		$base.day_$i configure -state normal
	}
	for { set i [expr $days + 1] } { $i <= 31 } { incr i } {
		$base.day_$i configure -state disabled
	}
	
	#Enable all month
	if { $current(month) != "" } {
		$current(month) configure -fg $colours(normal)
	}

	#Disable the selected month
	set name [lindex $month_name $month]
	.months.but_$name configure -fg $colours(current)
	set current(month) ".months.but_$name"
	#Enable all days
	if { $current(day) != "" } {
		$current(day) configure -fg $colours(normal)
	}
}

#This function will be called when the application exits
proc exiter { } {
	global current date opt option_file program
	set data "#This file is generated by $program(name) V$program(version).\n#Do not edit unless you know what you are doing.\n"
	#Get the options
	foreach name [array names opt] {
		append data "set opt($name)	$opt($name)\n"
	}
	foreach name [array names date] {
		append data "set date($name)	$date($name)\n"
	}
	foreach name [array names current] {
		append data "set current($name)	$current($name)\n"
	}

	#Write the file
	#The catchs are there so that no error will come even if it is 
	#	run from a CD-ROM(non writeable medium)
	if { ![catch { set opt_file [open "$option_file" w]}] } {
		catch { puts $opt_file $data }
		close $opt_file
	}
	exit
}

################################## GUI Functions #########################################

#Make the buttons for all the Months
proc makeMonths { base type } {
	set month_short { "" "jan" "feb" "mar" "apr" "may" "june" "july" "aug" "sept" "oct" "nov" "dec" }
	set month_name  { "" "January" "February" "March" "April" "May" "June" "July" \
			"Augest" "September" "October" "November" "December" }
			
	for { set i 1 } { $i <= 12 } { incr i } {
		set name "[lindex $month_name $i]"
		if { $type == "menu" } {
			$base add command -label "$name" -command "monthDays $i"
		} else {
			set short "[lindex $month_short $i]"
			button $base.but_$short -command "monthDays $i" -text "$name"
		}
	}

	if { $type != "menu" } {
		pack $base.but_jan  $base.but_feb $base.but_mar $base.but_apr \
			 $base.but_may  $base.but_june -side left -padx 2 -fill x
		pack $base.but_july $base.but_aug $base.but_sept $base.but_oct \
			 $base.but_nov  $base.but_dec  -side left -padx 2 -fill x
	}
}

#Make all the years - folders that existing in the archive folder.
proc makeYears { base } {
	global archive_folder
	set latest ""
	set folders [lsort [glob -nocomplain [file join $archive_folder *]]]

	foreach dir $folders {
		set name [file tail $dir]
		#Check wheter the got file is a folder and has 4 digits as its name
		if { [file isdirectory $dir] && [regexp "\[0-9\]{4}" $name] } {
			$base add command -label "$name" -underline 3 -command "setYear $name 1"
			set latest $name
		}
	}
	return $latest
}

#Launch the browser no matter what OS the user is having
proc launchBrowser { url } {
	global tcl_platform
	
	set flag 0
	# It *is* generally a mistake to switch on $tcl_platform(os), particularly
	# in comparison to $tcl_platform(platform).  For now, let's just regard it
	# as a stylistic variation subject to debate.
	switch $tcl_platform(os) {
		Darwin {
			set command [list open $url]
			}
		HP-UX -
		Linux  -
		SunOS {
			foreach executable {mozilla netscape iexplorer opera lynx
					w3m links galeon konquerer mosaic firefox amaya
					browsex elinks} {
				set executable [auto_execok $executable]
				if [string length $executable] {
					# Do you want to mess with -remote?  How about other browsers?
					set command [list $executable $url &]
					break
				}
			}
		}
		{Windows 95} -
		{Windows NT} {
			exec rundll32 url.dll,FileProtocolHandler $url &
			set flag 1
			#set command "rundll32 url.dll,FileProtocolHandler $url &"
			#set command "[auto_execok start] {} [list $url]"
		}
	}

	if { !$flag } {
		if { [info exists command] } {
			if [catch {exec {expand}$command} err] {
				tk_messageBox -icon error -message "Error '$err' with '$command'"
			}
		} else {
			tk_messageBox -icon error -message \
				"($tcl_platform(os), $tcl_platform(platform)) is not yet ready for browsing."
		}
	}
}

# This function will make the menu bar at the top of the window. I thought
# 	that I will seperate it from the main GUI programming.
# Arguments : m - m is the id of the menu.
proc makeMenu { m } {
global archive_folder opt program

menu $m
#The Main Buttons
$m add cascade -label "Program" -underline 0 -menu [menu $m.prog -tearoff 0]
$m add cascade -label "Date" -underline 0 -menu [menu $m.date -tearoff 0]
$m add cascade -label "Preferences" -underline 0 -menu [menu $m.pref -tearoff 0]
$m add cascade -label "Help" -menu [menu $m.help -tearoff 0]

## File Menu ##
set c $m.prog
$c add command -label "Base Folder" -underline 0 -command {
	#Opens the Directory chosing dialog.
	set folder [tk_chooseDirectory -mustexist yes]
	if { $folder != "" } {
		set archive_folder $folder
		init
	}
}
$c add separator
$c add command -label "Exit" -underline 1 -command exiter

## Date Menu ##
set c $m.date
$c add cascade -label "Days" -underline 0 -menu [menu $m.mnu_days -tearoff 0]
makeDays "$m.mnu_days" "menu"
$c add cascade -label "Months" -underline 0 -menu [menu $m.mnu_months -tearoff 0]
makeMonths "$m.mnu_months" "menu"
$c add cascade -label "Year" -underline 1 -menu [menu $m.mnu_years -tearoff 0]
makeYears "$m.mnu_years"

## Preferences Menu ##
set c $m.pref
$c add checkbutton -label "Show Replys" -underline 0 -variable opt(show_replys) -command { toogleReply }
$c add checkbutton -label "Only Current Message" -underline 5 -variable current(show_only) -command { showOnly }
$c add checkbutton -label "Use Bigger Font" -underline 4 -variable opt(use_big_font) \
	-command { 
		if { $opt(use_big_font) } {
			.msg configure -font "-Adobe-Courier-*-R-Normal--*-130-*-*-*-*-*-*"
		} else {
			.msg configure -font "ansi"
		}
	}
$c add checkbutton -label "Use Vertical Layout" -underline 4 -variable opt(use_vertical) \
	-command {
		if { !$opt(use_vertical) } {
			.pnd_both configure -orient v
		} else {
			.pnd_both configure -orient h
		}
	}

## Help Menu ##
set c $m.help
$c add command -label "Author's Website" -underline 0 -command { launchBrowser "http://www.geocities.com/binnyva" }
$c add command -label "$program(name) Page" -underline 0 -command { launchBrowser "http://www.geocities.com/binnyva/code/tcl/scripts/usenet/" }
$c add command -label "Download Archive Files" -underline 0 -command { launchBrowser "http://www.oche.de/~akupries/tcltk.html#clt-arch" }
$c add separator
$c add command -label "About" -underline 0 -command { 
	tk_messageBox -type ok -title "About $program(name)" -message \
"$program(name) V $program(version)

by Binny V Abraham

$program(email)
$program(website)"
}
}

#Show the specified text as the status for a second and then clear it
proc stat { msg } {
	.status configure -text "$msg"
	after 2000 { .status configure -text "Ready" }
}
#Show status for specifed time and clear it.
proc statu { msg delay } {
	.status configure -text "$msg"
	#If it is given in seconds rather than milliseconds.
	if { $delay < 20 } {
		set delay [expr $delay * 1000]
	}
	#Error Info. Put in red colour
	if { $delay == 6000 } {
		.status configure -fg red
		bell
	} 
	after $delay { .status configure -text "Ready" -fg black }
}
#Update the status bar
proc status { msg } {
	if { $msg != "" } {
		.status configure -text "$msg"
	} else {
		.status configure -text "Ready"
	}
}

################################## GUI Building #########################################

#Makes the menu
makeMenu ".menubar"
. configure -menu .menubar

#Year Buttons
frame .months
menubutton .months.mb_year -text "Year:     " -menu .months.mb_year.mnu \
	-border 2 -relief raised
menu .months.mb_year.mnu -tearoff 0
pack .months.mb_year -side left -padx 15

#Month Buttons
makeMonths ".months" "button"
pack .months

#Day Buttons
frame .days
makeDays ".days" "button"
pack .days

#The Info Bar
frame .frm_info
label .subject_name -anchor w -text "Subject:"
label .date      -bd 1 -relief sunken -width 10 -text ""
label .msg_count -bd 1 -relief sunken -width 15 -text "0 Message(s)"
button .but_date -text "Show Post" -command { showPost }
pack .subject_name -in .frm_info -side left -padx 1 -expand 0
pack .but_date    -in .frm_info -side right -padx 1
pack .msg_count   -in .frm_info -side right -padx 1
pack .date        -in .frm_info -side right -padx 1
pack .frm_info -fill x

panedwindow .pnd_both -orient v -sashpad 3 -sashwidth 3 -opaqueresize 0
#The Subjects Area
frame .frm_subs
listbox .subjects -yscrollcommand ".srl_subs_y set" -width 45
bind .subjects <Double-ButtonPress-1> { showPost }
scrollbar .srl_subs_y -command ".subjects yview" -orient v
pack .subjects   -in .frm_subs -fill both -expand 1 -side left
pack .srl_subs_y -in .frm_subs -fill y -expand 1

#The Message Area
frame .frm_msg
text .msg -wrap word -yscrollcommand ".srl_msg_y set" 
scrollbar .srl_msg_y -command ".msg yview" -orient v
pack .msg -in .frm_msg -fill both -side left -expand 1
pack .srl_msg_y -in .frm_msg -fill y -expand 1

.pnd_both add .frm_subs
.pnd_both add .frm_msg
pack .pnd_both -fill both -expand 1

#Status Bar
frame .frm_stat
label .status -text "Ready" -anchor w
label .file_info -bd 1 -relief sunken -width 20 -text "Empty"
label .from -bd 1 -relief sunken -width 20
bind .from <ButtonPress-1> { postInfo }
button .but_edit -text "Edit Message" -command { openForEdit }
pack .status    -in .frm_stat -side left -padx 1 -expand 0
pack .but_edit  -in .frm_stat -side right -padx 1
pack .from      -in .frm_stat -side right -padx 1
pack .file_info -in .frm_stat -side right -padx 1
pack .frm_stat -side left -fill x -expand 1

wm title . "$program(name) V$program(version)"

bind . <Key-Escape> { exiter }
wm protocol . WM_DELETE_WINDOW { exiter }

#The Inititialization Function
proc init {} {
	global date current opt option_file

	#Load saved options
	catch { source "$option_file" }
	
	set latest [makeYears ".months.mb_year.mnu"]
	#tk_messageBox -message "$latest"
	if { $latest == "" } {
		tk_messageBox -message "Comp.Lang.Tcl Archives not found.\nPlease put the script in the same folder were the archives are kept." -icon error
	} else {
		setYear $latest 0
		monthDays 1
 		getSubjects 1
	}
 	
 	if { $opt(use_vertical) } {
		.pnd_both configure -orient h
	}
}
init

###################################  To Do  ########################################
# Show error if there is no folder of any year or if the stucture is invalid
